// BasicSampleView.h : interface of the CBasicSampleView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASICSAMPLEVIEW_H__8E4654CC_29A2_4DD4_9447_3B784FC4735F__INCLUDED_)
#define AFX_BASICSAMPLEVIEW_H__8E4654CC_29A2_4DD4_9447_3B784FC4735F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//*************************************************************************************
// class CBasicSampleView
//*************************************************************************************
class CBasicSampleView : public CView
{
protected: // create from serialization only
	CBasicSampleView();
	DECLARE_DYNCREATE(CBasicSampleView)

// Attributes
public:
	CBasicSampleDoc* GetDocument();

// Operations
public:

   void  GetCellRect( int iCol, int iRow, CRect& rcCell ) const;
   void  HilightCell( int iCol, int iRow );
   void  ShowCoords( int iCol, int iRow );


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasicSampleView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBasicSampleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Data Members
   CArray< CDelegate2<int,int>, CDelegate2<int,int> > m_MouseEvents;
   CPoint               m_curCell;
   CPoint               m_prevCell;

// Generated message map functions
protected:
	//{{AFX_MSG(CBasicSampleView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnShowCoord();
	afx_msg void OnHilight();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//*************************************************************************************


//*************************************************************************************
#ifndef _DEBUG  // debug version in BasicSampleView.cpp
inline CBasicSampleDoc* CBasicSampleView::GetDocument()
   { return (CBasicSampleDoc*)m_pDocument; }
#endif
//*************************************************************************************


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASICSAMPLEVIEW_H__8E4654CC_29A2_4DD4_9447_3B784FC4735F__INCLUDED_)
