// DelegatesMT.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "DelegatesMT.h"

#include <conio.h>

#include "DlgTime.h"
#include "Demo.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// The one and only application object
CWinApp theApp;


//*************************************************************************************
// main
//*************************************************************************************
int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
   int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}

   CDlgTime dlg;
   dlg.Create( IDD_TIME );
   dlg.ShowWindow( SW_SHOW );


   // --------- DEMO

   CEmployee Charles( "Charles" ), Jim( "Jim" );

   Charles.Reporter( ).Add( Report );
   Jim.Reporter( ).Add( Report );

   CWayOfLife_Theorical wCharles( Charles );
   CWayOfLife_Concrete  wJim( Jim );

   CClock::Suscribers( ).Add( wCharles, CWayOfLife::Action );
   CClock::Suscribers( ).Add( wJim, CWayOfLife::Action );
   CClock::Start( );

   while( CClock::IsRunning( ) )
   {
      CClock::Format( dlg.m_sTime );
      dlg.UpdateData( false );
   };


   // --------- END DEMO

   cout << "press any key to continue..." << endl;
   getch( );
   
   return nRetCode;
}
//*************************************************************************************

