// BasicSampleDoc.cpp : implementation of the CBasicSampleDoc class
//

#include "stdafx.h"
#include "BasicSample.h"

#include "BasicSampleDoc.h"
#include "DlgDim.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//*************************************************************************************
IMPLEMENT_DYNCREATE(CBasicSampleDoc, CDocument)
//*************************************************************************************


//*************************************************************************************
BEGIN_MESSAGE_MAP(CBasicSampleDoc, CDocument)
	//{{AFX_MSG_MAP(CBasicSampleDoc)
	ON_COMMAND(ID_DIM, OnDim)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//*************************************************************************************


//*************************************************************************************
// CBasicSampleDoc construction/destruction
//*************************************************************************************
CBasicSampleDoc::CBasicSampleDoc()  
:  m_iCols( 12 ),
   m_iRows( 8 ),
   m_converter( m_iCols, m_iRows )
{
	// TODO: add one-time construction code here

}
//*************************************************************************************
CBasicSampleDoc::~CBasicSampleDoc()
{
}
//*************************************************************************************
BOOL CBasicSampleDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}
//*************************************************************************************



//*************************************************************************************
// CBasicSampleDoc serialization
//*************************************************************************************
void CBasicSampleDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}
//*************************************************************************************



//*************************************************************************************
// CBasicSampleDoc diagnostics
//*************************************************************************************
#ifdef _DEBUG
//*************************************************************************************
void CBasicSampleDoc::AssertValid() const
{
	CDocument::AssertValid();
}
//*************************************************************************************
void CBasicSampleDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
//*************************************************************************************
#endif //_DEBUG
//*************************************************************************************


//*************************************************************************************
// CBasicSampleDoc commands
//*************************************************************************************
void CBasicSampleDoc::OnDim() 
{
   CDlgDim dlg;

   dlg.m_iCols = m_iCols;
   dlg.m_iRows = m_iRows;

   if( dlg.DoModal( ) != IDOK )
      return;

   const bool bUpdate = (m_iCols != dlg.m_iCols) || (m_iRows != dlg.m_iRows);
   
   if( bUpdate )
   {
      m_iCols = dlg.m_iCols;
      m_iRows = dlg.m_iRows;
      m_converter.SetDim( m_iCols, m_iRows );

      UpdateAllViews( NULL, NULL, NULL );
   }
}
//*************************************************************************************
