// BasicSampleDoc.h : interface of the CBasicSampleDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASICSAMPLEDOC_H__270E5DE3_67D9_40F1_9CF8_CB4E86CDA6F4__INCLUDED_)
#define AFX_BASICSAMPLEDOC_H__270E5DE3_67D9_40F1_9CF8_CB4E86CDA6F4__INCLUDED_

#include "TemplateTools.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//*************************************************************************************
// class CBasicSampleDoc
//*************************************************************************************
class CBasicSampleDoc : public CDocument
{
protected: // create from serialization only
	CBasicSampleDoc();
	DECLARE_DYNCREATE(CBasicSampleDoc)

// Attributes
public:

   int   Cols  ( ) const { return m_iCols; }
   int   Rows  ( ) const { return m_iRows; }
   int&  Cols  ( )       { return m_iCols; }
   int&  Rows  ( )       { return m_iRows; }
   int   Size  ( ) const { return m_iCols*m_iRows; }
   const DimConverter<2>& Converter( ) const { return m_converter; }


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasicSampleDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBasicSampleDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   
// Data Members

   int                  m_iCols;
   int                  m_iRows;
   DimConverter<2>      m_converter;
   

// Generated message map functions
protected:
	//{{AFX_MSG(CBasicSampleDoc)
	afx_msg void OnDim();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//*************************************************************************************


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASICSAMPLEDOC_H__270E5DE3_67D9_40F1_9CF8_CB4E86CDA6F4__INCLUDED_)
